/***********************************************************************
*
* asmoptab.c - Opcode table for the TI 990 assembler.
*
* Changes:
*   05/21/03   DGP   Original.
*
***********************************************************************/


#include "asmdef.h"

extern SymNode *symbols[MAXSYMBOLS];

OpCode optable[NUMOPS] =
{
   { "A", 0xA000, 0, TYPE_1 },
   { "AB", 0xB000, 0, TYPE_1 },
   { "ABS", 0x0740, 0, TYPE_6 },
   { "AI", 0x0220, 0, TYPE_8 },
   { "ANDI", 0x0240, 0, TYPE_8 },
   { "AORG", AORG_T, 0, TYPE_P },
   { "B", 0x0440, 0, TYPE_6 },
   { "BES", BES_T, 0, TYPE_P },
   { "BL", 0x0680, 0, TYPE_6 },
   { "BLWP", 0x0400, 0, TYPE_6 },
   { "BSS", BSS_T, 0, TYPE_P },
   { "BYTE", BYTE_T, 0, TYPE_P },
   { "C", 0x8000, 0, TYPE_1 },
   { "CB", 0x9000, 0, TYPE_1 },
   { "CI", 0x0280, 0, TYPE_8 },
   { "CKOF", 0x03C0, 0, TYPE_7 },
   { "CKON", 0x03A0, 0, TYPE_7 },
   { "CLR", 0x04C0, 0, TYPE_6 },
   { "COC", 0x2000, 0, TYPE_3 },
   { "CZC", 0x2400, 0, TYPE_3 },
   { "DATA", DATA_T, 0, TYPE_P },
   { "DEC", 0x0600, 0, TYPE_6 },
   { "DECT", 0x0640, 0, TYPE_6 },
   { "DEF", DEF_T, 0, TYPE_P },
   { "DIV", 0x3C00, 0, TYPE_9 },
   { "DORG", DORG_T, 0, TYPE_P },
   { "DXOP", DXOP_T, 0, TYPE_P },
   { "END", END_T, 0, TYPE_P },
   { "EQU", EQU_T, 0, TYPE_P },
   { "EVEN", EVEN_T, 0, TYPE_P },
   { "IDLE", 0x0340, 0, TYPE_7 },
   { "IDT", IDT_T, 0, TYPE_P },
   { "INC", 0x0580, 0, TYPE_6 },
   { "INCT", 0x05C0, 0, TYPE_6 },
   { "INV", 0x0540, 0, TYPE_6 },
   { "JEQ", 0x1300, 0, TYPE_2 },
   { "JGT", 0x1500, 0, TYPE_2 },
   { "JH", 0x1B00, 0, TYPE_2 },
   { "JHE", 0x1400, 0, TYPE_2 },
   { "JL", 0x1A00, 0, TYPE_2 },
   { "JLE", 0x1200, 0, TYPE_2 },
   { "JLT", 0x1100, 0, TYPE_2 },
   { "JMP", 0x1000, 0, TYPE_2 },
   { "JNC", 0x1700, 0, TYPE_2 },
   { "JNE", 0x1600, 0, TYPE_2 },
   { "JNO", 0x1900, 0, TYPE_2 },
   { "JOC", 0x1800, 0, TYPE_2 },
   { "JOP", 0x1C00, 0, TYPE_2 },
   { "LDCR", 0x3000, 0, TYPE_4 },
   { "LI", 0x0200, 0, TYPE_8 },
   { "LIMI", 0x0300, 1, TYPE_8 },
   { "LIST", LIST_T, 0, TYPE_P },
   { "LREX", 0x03E0, 0, TYPE_7 },
   { "LWPI", 0x02E0, 1, TYPE_8 },
   { "MOV", 0xC000, 0, TYPE_1 },
   { "MOVB", 0xD000, 0, TYPE_1 },
   { "MPY", 0x3800, 0, TYPE_9 },
   { "NEG", 0x0500, 0, TYPE_6 },
   { "NOP", NOP_T, 0x1000, TYPE_P },
   { "OPTION", OPTION_T, 0, TYPE_P },
   { "ORI", 0x0260, 0, TYPE_8 },
   { "PAGE", PAGE_T, 0, TYPE_P },
   { "REF", REF_T, 0, TYPE_P },
   { "RORG", RORG_T, 0, TYPE_P },
   { "RSET", 0x0360, 0, TYPE_7 },
   { "RT", RT_T, 0x045B, TYPE_P },
   { "RTWP", 0x0380, 0, TYPE_7 },
   { "S", 0x6000, 0, TYPE_1 },
   { "SB", 0x7000, 0, TYPE_1 },
   { "SBO", 0x1D00, 1, TYPE_2 },
   { "SBZ", 0x1E00, 1, TYPE_2 },
   { "SETO", 0x0700, 0, TYPE_6 },
   { "SLA", 0x0A00, 0, TYPE_5 },
   { "SOC", 0xE000, 0, TYPE_1 },
   { "SOCB", 0xF000, 0, TYPE_1 },
   { "SRA", 0x0800, 0, TYPE_5 },
   { "SRC", 0x0B00, 0, TYPE_5 },
   { "SRL", 0x0900, 0, TYPE_5 },
   { "STCR", 0x3400, 0, TYPE_4 },
   { "STST", 0x02C0, 2, TYPE_8 },
   { "STWP", 0x02A0, 2, TYPE_8 },
   { "SWPB", 0x06C0, 0, TYPE_6 },
   { "SZC", 0x4000, 0, TYPE_1 },
   { "SZCB", 0x5000, 0, TYPE_1 },
   { "TB", 0x1F00, 1, TYPE_2 },
   { "TEXT", TEXT_T, 0, TYPE_P },
   { "TITL", TITL_T, 0, TYPE_P },
   { "UNL", UNL_T, 0, TYPE_P },
   { "X", 0x0480, 0, TYPE_6 },
   { "XOP", 0x2C00, 0, TYPE_9 },
   { "XOR", 0x2800, 0, TYPE_3 }
};

/***********************************************************************
* oplookup - Lookup opcode.
***********************************************************************/

OpCode *
oplookup (char *op)
{
   OpCode *ret = NULL;
   int done = FALSE;
   int mid;
   int last = 0;
   int lo;
   int up;
   int r;
   static OpCode top;
   static SymNode *s;

#ifdef DEBUGOP
   printf ("oplookup: Entered: op = %s\n", op);
#endif

   lo = 0;
   up = NUMOPS;
   
   while (!done)
   {
      mid = (up - lo) / 2 + lo;
#ifdef DEBUGOP
      printf (" mid = %d, last = %d\n", mid, last);
#endif
      if (last == mid) break;
      r = strcmp (optable[mid].opcode, op);
      if (r == 0)
      {
         ret = &optable[mid];
	 done = TRUE;
      }
      else if (r < 0)
      {
         lo = mid;
      }
      else 
      {
         up = mid;
      }
      last = mid;
   }

   /*
   ** If not found, check if DXOP defined
   */

   if (ret == NULL)
   {

      if ((s = symlookup (op, FALSE)) != NULL)
      {
	 if (s->xop)
	 {
	    top.opcode = s->symbol;
	    top.opvalue = 0x2C00 | (s->value << 6); 
	    top.opmod = 0;
	    top.optype = TYPE_6;
	    ret = &top;
	 }
      }
   }
#ifdef DEBUGOP
   printf (" ret = %8x\n", ret);
#endif
   return (ret);
}
